s         ::=  ws grammar ws                  => "gram"
ws       !::=  w**
grammar   ::=  r +/ ws                        => "grammar"
r         ::=  word  ^"::=" alternatives /ws
            |  word ^"!::=" alternatives /ws

alternatives  ::=  equiAlt   +/ (ws ">" ws)
equiAlt       ::=  conjuncts +/ (ws "|" ws)

conjuncts   ::=  sequence
              |  sequence ^"&"  e*/ws   /ws
              |  sequence ^"&~" e*/ws   /ws

sequence    ::= e*/ws
                (ws "/" e)?
                (ws "=>" ws (word|quoted))?              => "seq"

ec       ::= [~\-\]\\\~]
           | escaped

range    ::= ec          => "range"
           | ec ^"-" ec

e        ::= word                             => "nonTerminal"
           |    [(][)]                        => "epsilon"
           |    ^"{" alternatives "}"   /ws
           |    ^"["  (range*) "]"
           |    ^"[~" (range*) "]"
           |    ^"^" quoted             /ws
           |    ^"!" e                  /ws

           |  (e ws ^"**" > e ws ^"*")
           |  e ^"*/" e                 /ws
           |  (e ws ^"++" > e ws ^"+")
           |  e ^"+/" e                 /ws
           |  e ^"?"                    /ws

           |  quoted                        => "literal"

           |     "(" word ^")"          /ws
           >    ^"(" alternatives ")"   /ws

w       !::= " "
           | "//" ([~\n]*) "\n"
           | "\n"
           | "\r"
word     ::= [a-zA-Z0-9_]++
quoted   ::= "\"" (([~\"\\] | escaped)+) "\""
           | "\"\"" => ""
escaped  ::= "\\n" => "\n"
           | "\\r" => "\r"
           | "\\" [~nr]


